#include "monsleepwakeup.h"

#include <unistd.h>
#include <signal.h>
#include <stdio.h>

static sigset_t old, new;
static struct sigaction action;
 
#define MESSAGE(string) fprintf(stderr, \
				"[%d] " string "\n",getpid())

void wakeup_handler(int sig){
  return ;
}

void mon_sleep(void)
{
  MESSAGE("Je m'endort");
  
  /* Essayer ce qu'il arrive si l'on substitue la ligne suivante */
  /* avec la ligne */
  /* pause() ; */

  sigsuspend(&old);
  
  MESSAGE("Je me reveille");
  return;
}

void mon_wakeup(int pid)
{
  kill(pid,SIGUSR1);
}

#ifdef LONG_INIT
void init_sleepwakeup(void)
{
  MESSAGE("Initisaltion : code long");
  
  /* Old contiendra la masque courante 
     moins SIGUSR1 */
  sigprocmask(SIG_SETMASK,NULL,&old);
  if(sigismember(&old,SIGUSR1))
    sigdelset(&old,SIGUSR1);

  /* New contiendra la masque courante 
     plus SIGUSR1 */
  sigprocmask(SIG_SETMASK,NULL,&new);
  sigaddset(&new,SIGUSR1);

  /* La masque courante 
     est de maintenant une copie de new */
  sigprocmask(SIG_SETMASK,&new,NULL);

  /* Initialiser l'action 
     et associer cette action  SIGUSR1 */ 
  action.sa_flags=0;
  action.sa_handler=wakeup_handler;
  sigemptyset(&action.sa_mask);
  sigaction(SIGUSR1,&action,NULL);
}
#else
/* Code quivalent, plus bref */
void init_sleepwakeup(void)
{
  MESSAGE("Initialistion : code court");

  /* new contient le seul signal SIGUSR1 */
  sigemptyset(&new);
  sigaddset(&new,SIGUSR1);
  
  /* 
     Old contiendra la vielle masque moins SIGUSR1,
     La masque courante devient masque + SIGUSR1
  */
  sigprocmask(SIG_BLOCK,&new,&old);
  if(sigismember(&old,SIGUSR1))
    sigdelset(&old,SIGUSR1);

  /* Initialiser l'action 
     et associer cette action  SIGUSR1 */ 
  action.sa_flags=0;
  action.sa_handler=wakeup_handler;
  sigemptyset(&action.sa_mask);
  sigaction(SIGUSR1,&action,NULL);
}

#endif /* LONG_INIT */
